//+------------------------------------------------------------------+
//|                                                         Kris.mq4 |
//+------------------------------------------------------------------+
//|                                              Indicator Power.mq4 |
//|                                                      K.Piligrimm |
//|                                             piligrimm_fx@mail.ru |
//+------------------------------------------------------------------+
#property copyright "K.Piligrimm"
#property link      "K.Piligrimm"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Magenta

//---- input parameters

static datetime time0=0;          

extern int LengthSample=1300;    //      .
extern int Threshold= 111;
extern int DynamicMode= 0;
extern int SaveFileData= 0;
extern string FileNamePower=  "Power.csv";
extern int Subscripting_MT4= 0;   
extern string NameGlobalVariableGP_0="GP_0";
extern string NameGlobalVariableGP_1="GP_1";
extern string NameGlobalVariableGP_2="GP_2";               
int mc0=0,k0=0,Bars1;  
double GV[],GM1[],JS0[][2],GM[],Ex0,Ex1,Ex2,GP_0,GP_1,GP_2; 

//---- buffers
double ExtMapBuffer1[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   
    SetIndexStyle(0, DRAW_LINE,STYLE_SOLID,3);
    SetIndexDrawBegin(0,LengthSample);
    SetIndexBuffer(0,ExtMapBuffer1);
    
    
  
    Ex0=0;Ex1=0;Ex2=0;
    GlobalVariableSet(NameGlobalVariableGP_0, Ex0);
    GlobalVariableSet(NameGlobalVariableGP_1, Ex1);
    GlobalVariableSet(NameGlobalVariableGP_2, Ex2);    
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
    GlobalVariableDel(NameGlobalVariableGP_0); 
    GlobalVariableDel(NameGlobalVariableGP_1);
    GlobalVariableDel(NameGlobalVariableGP_2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
    {//0
     
    if(time0 == Time[0]) return(0);  ////////////////////////////////
        time0 = Time[0];              //////////////////////////////// 


    double MS[1],PIP[2],Mt,GM2[];
    int m,j,i,nn,nt=0,iq,jm,m0,m1,nq,handle,dm;
    PIP[1]=Threshold*Point; PIP[0]=NormalizeDouble(PIP[1]/5,Digits);
    if (DynamicMode==0)
   {//DM=0 
      Bars1=LengthSample+100;
    ArrayResize(GM1, LengthSample+101);
    ArrayResize(JS0, LengthSample+100);
    ArrayResize(GM, LengthSample+100); 
    ArrayResize(GM2, LengthSample+101);
    ArrayResize(GV, LengthSample);
    
     
       JS0[0][0]=Close[Bars1];JS0[0][1]=0;     
    for (i=0; i<Bars1; i++)  
     {//5
       m=Bars1-i;
       Mt=MathAbs(Close[Bars1]-Close[m]);
    if (Mt>PIP[0]/5)
     {//4
       JS0[1][0]=Close[m];JS0[1][1]=i;nt=i;
       i=Bars1;
     }//4  
     }//5 
       k0=1; 
       m=Bars1;
       
     for( nn=nt; nn<Bars1; nn++)
     {//6
     
    if ((Low[m-nn]-JS0[k0][0])<-PIP[1])  
      {//7
       k0++;
       JS0[k0][0]=Low[m-nn];JS0[k0][1]=nn;
      }//7
    else if ((High[m-nn]-JS0[k0][0])>PIP[1]) 
      {//8
       k0++;
       JS0[k0][0]=High[m-nn];JS0[k0][1]=nn; 
      }//8
    if ((JS0[k0-1][0]>JS0[k0][0])&&((Low[m-nn]-JS0[k0][0])<0))
       
      if ((Low[m-nn]-JS0[k0-1][0])<-PIP[0])  
      {//9
       k0++;
       JS0[k0][0]=Low[m-nn];JS0[k0][1]=nn;
      }//9
    else   
      {//10
       JS0[k0][0]=Low[m-nn];JS0[k0][1]=nn; 
      }//10 
    else if ((JS0[k0-1][0]<JS0[k0][0])&&((High[m-nn]-JS0[k0][0])>0))
       
      if ((High[m-nn]-JS0[k0-1][0])>PIP[0]) 
      {//11
       k0++;
       JS0[k0][0]=High[m-nn];JS0[k0][1]=nn; 
      }//11
    else  
      {//12
       JS0[k0][0]=High[m-nn];JS0[k0][1]=nn; 
      }//12   
      }//6
      
       GM[0]=JS0[0][0];
    for(iq=1; iq<k0; iq++)
     {//13    
       m0=JS0[iq][1];
       m1=JS0[iq+1][1];
       GM[iq]=0;
    for(jm=m0; jm<=m1; jm++) 
       GM[iq]=GM[iq]+(Close[Bars1-jm]+Low[Bars1-jm] +High[Bars1-jm])/3;
       m=(m1-m0+1);
       GM[iq]=GM[iq]/m;
     }//13 
       GM[k0]=0;
    for(jm=m1; jm<Bars1; jm++) 
       GM[k0]=GM[k0]+(Close[Bars1-jm]+Low[Bars1-jm] +High[Bars1-jm])/3;
       GM[k0]=GM[k0]/(Bars1-m1);   
       GM1[0]=GM[0];
       nq=0;      
       
    for(iq=1; iq<k0; iq++)
     {//13    
       m=JS0[iq+1][1]-JS0[iq][1];
       if (m==0)
       m=1;   
    for(jm=0; jm<m; jm++) 
     {//14
       nq++;
       GM1[nq]=GM[iq];
     }//14 
     }//13 

       m=Bars1-JS0[k0][1];
    for(jm=0; jm<=m; jm++) 
     {//14
       nq++;
       GM1[nq]=GM[k0];
     }//14
     
       m=nq-LengthSample;
    for (i=0; i<LengthSample; i++)
        GV[i]=NormalizeDouble(GM1[i+m],Digits);
          
    for(j=0; j<LengthSample; j++)   
      ExtMapBuffer1[LengthSample-j]=GV[j];
    dm=LengthSample;  
     }//DM=0
   else if (DynamicMode==1)
   {//DM=1
     ArrayResize(GM1, mc0+1);
     ArrayResize(JS0, mc0+1);
     ArrayResize(GM, mc0+1); 
     ArrayResize(GM2, mc0+1);
     ArrayResize(GV, mc0+1);
    if ((mc0>0)&&(k0==0))
    {//        
       JS0[0][0]=Close[1];JS0[0][1]=0;     
       Mt=MathAbs(Close[1]-Close[mc0]);
    if (Mt>PIP[0]/5)
     {//4
       JS0[1][0]=Close[1];JS0[1][1]=mc0;
       k0=1;
     }//4  
    }//    
   if (k0>0)
    {// k0 
    if ((Low[1]-JS0[k0][0])<-PIP[1])  
      {//7
       k0++;
       JS0[k0][0]=Low[1];JS0[k0][1]=mc0;
      }//7
    else if ((High[1]-JS0[k0][0])>PIP[1]) 
      {//8
       k0++;
       JS0[k0][0]=High[1];JS0[k0][1]=mc0; 
      }//8
    if ((JS0[k0-1][0]>JS0[k0][0])&&((Low[1]-JS0[k0][0])<0))
       
      if ((Low[1]-JS0[k0-1][0])<-PIP[0])  
      {//9
       k0++;
       JS0[k0][0]=Low[1];JS0[k0][1]=mc0;
      }//9
    else   
      {//10
       JS0[k0][0]=Low[1];JS0[k0][1]=mc0; 
      }//10 
    else if ((JS0[k0-1][0]<JS0[k0][0])&&((High[1]-JS0[k0][0])>0))
       
      if ((High[1]-JS0[k0-1][0])>PIP[0]) 
      {//11
       k0++;
       JS0[k0][0]=High[1];JS0[k0][1]=mc0; 
      }//11
    else  
      {//12
       JS0[k0][0]=High[1];JS0[k0][1]=mc0; 
      }//12   
        
       GM[k0]=0;m=mc0-JS0[k0][1];
    for(jm=0; jm<m; jm++) 
       GM[k0]=GM[k0]+(Close[jm]+Low[jm] +High[jm])/3;
     if (m==0)
      {//
       m=1; 
       GM[k0]=(Close[1]+Low[1] +High[1])/3;
       }//
     else if (m!=0)  
       GM[k0]=GM[k0]/m;   
       GM1[0]=GM[0];
       nq=0;      
       
    for(iq=1; iq<k0; iq++)
     {//13    
       m=JS0[iq+1][1]-JS0[iq][1];
       if (m==0)
       m=1;   
    for(jm=0; jm<=m; jm++) 
     {//14
       nq++;
       GM1[nq]=GM[iq];
     }//14 
     }//13 

       m=mc0-JS0[k0][1]+1;
    for(jm=0; jm<=m; jm++) 
     {//14
       nq++;
       GM1[nq]=GM[k0];
     }//14

     dm=nq+1;
     for (i=0; i<dm; i++)
        GV[i]=NormalizeDouble(GM1[i],Digits);
     
     for(j=0; j<dm; j++)
     ExtMapBuffer1[nq-j-1]=GV[j];
     }//k0  
    }//DM=1  
       Ex2=GM[k0-2];Ex1=GM[k0-1];Ex0=GM[k0];     
       GlobalVariableSet(NameGlobalVariableGP_0, Ex0);
       GlobalVariableSet(NameGlobalVariableGP_1, Ex1);
       GlobalVariableSet(NameGlobalVariableGP_2, Ex2); 
       GP_0=GlobalVariableGet(NameGlobalVariableGP_0);
       GP_1=GlobalVariableGet(NameGlobalVariableGP_1);
       GP_2=GlobalVariableGet(NameGlobalVariableGP_2);
       
     if (SaveFileData>0)
     {//
     if (Subscripting_MT4==0) 
      {//
      handle=FileOpen(FileNamePower,FILE_CSV|FILE_WRITE,',');
    if (handle>0)
     {//6  
    for(i=0; i<dm; i++)
     {//7
      MS[0]=GV[i];
      FileWrite(handle,MS[0]);
     }//7 
      FileClose(handle);
     }//6
     }//
     else if (Subscripting_MT4==1) 
      {//
      handle=FileOpen(FileNamePower,FILE_CSV|FILE_WRITE,',');
    if (handle>0)
     {//6  
    for(i=0; i<dm; i++)
     {//7
      MS[0]=GV[dm-i-1];
      FileWrite(handle,MS[0]);
     }//7 
      FileClose(handle);
     }//6
     }//
    }//
      mc0++;
 Comment("Indicator Power - creator K.Piligrimm <piligrimm_fx@mail.ru>", "\n","LengthSample"," ","= ",LengthSample,"  ","Threshold"," ","= ",Threshold,"  ","AmountRunning"," ","= ",mc0);
  
//----K
   return(0);

  

     }//1
//+------------------------------------------------------------------+